﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Diagrams;
using Telerik.Windows.Controls.Diagrams.Extensions;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows.Diagrams.Core;
using Telerik.Windows.DragDrop;

namespace WPF_Diagram_Application1
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            var source = new ObservableCollection<DataItem>();
            for (int i = 0; i < 10; i++)
            {
                source.Add(new DataItem() { Name = "Emploee " + i, Department = "Department " + i });
            }
            this.DataContext = source;

            DragDropManager.AddDragInitializeHandler(this.gridView, OnGridViewDragInit);
        }

        private void OnGridViewDragInit(object sender, DragInitializeEventArgs e)
        {
            var gridViewRow = e.OriginalSource as GridViewRow;
            if (gridViewRow != null)
            {
                e.AllowedEffects = DragDropEffects.Copy;

                DataItem data = (DataItem)gridViewRow.DataContext;

                var shape = new RadDiagramShape() { Content = data.Name + " - " + data.Department };
                var dropInfo = new DiagramDropInfo(new Size(100, 100), SerializationService.Default.SerializeItems(new List<IDiagramItem> { shape }));

                e.Data = dropInfo;
                e.DragVisual = new TextBlock() { Text = "Dragging: " + data.Name };
            }
        }
    }

    public class DataItem
    {
        public string Name { get; set; }
        public string Department { get; set; }
    }
}
